'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

var askConfigLocation = require('./ask-config-location');
var askExtensionsToCache = require('./ask-extensions-to-cache');
var askRootOfWebApp = require('./ask-root-of-web-app');
var askSWDest = require('./ask-sw-dest');

module.exports = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
  var globDirectory, globPatterns, swDest, configLocation, config;
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return askRootOfWebApp();

        case 2:
          globDirectory = _context.sent;
          _context.next = 5;
          return askExtensionsToCache(globDirectory);

        case 5:
          globPatterns = _context.sent;
          _context.next = 8;
          return askSWDest();

        case 8:
          swDest = _context.sent;
          _context.next = 11;
          return askConfigLocation();

        case 11:
          configLocation = _context.sent;
          config = {
            globDirectory,
            globPatterns,
            swDest
          };
          return _context.abrupt('return', {
            config,
            configLocation
          });

        case 14:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}));